/*

+GD +GF -GR +GS +GW +Q9

povray +Ima_screenplay_example2_tutorial.pov +Otest/test2.png +w800 +h600 -GR -A
povray +Ima_screenplay_example2_tutorial.pov +Otest/test2.png +w800 +h600 -GR +A Declare=SCR_CmdFS=5
povray +Ima_screenplay_example2_tutorial.pov +Otest/test2.png +w1280 +h720 -GR +A Declare=SCR_CmdFS=5

//The script aboarts itself when the last image was rendered, so use high numbers for +KFF
povray +Ima_screenplay_example2_tutorial.pov +Oanim2/anim0- +w400 +h300 -GR -A +KFI0 +KFF10000
povray +Ima_screenplay_example2_tutorial.pov +Oanim2/anim0- +w800 +h600 -GR -A +KFI0 +KFF10000
povray +Ima_screenplay_example2_tutorial.pov +Oanim2/anim0- +w1024 +h768 -GR +A +KFI0 +KFF10000
povray +Ima_screenplay_example2_tutorial.pov +Oanim2/anim0- +w1280 +h720 -GR +A +KFI0 +KFF10000

file:///home/pi/Projekte/povray/bibs/misc/ma_screenplay/test/


ffmpeg -r 20 -f image2 -i anim2/anim0-%05d.png -y -vcodec libx264 -crf 23 -pix_fmt yuv420p anim2/anim0.mp4

ffmpeg -r 5  -f image2 -i anim2/anim0-%05d.png -y -vcodec libx264 -crf 23 -pix_fmt yuv420p anim2/anim0.mp4

convert -delay 30 anim2/anim0-*.png anim2/anim0_x.gif
convert -delay 10 anim2/anim0-*.png anim2/anim0_x.gif

rm anim2/anim0-*.png


*/


// -------------------------------------------------------------------
// Start of file and common povray-stuff
// -------------------------------------------------------------------

#version 3.7;

global_settings		{
	assumed_gamma 1.0
	charset utf8
}
#default {
	texture { pigment { color rgb <0.9,0.0,0.5> } }
	finish { ambient 0.1 diffuse 0.99 }
}

#include "colors.inc"
#include "textures.inc"




//-----------------------------------------------------------------------------------------------------
//Try to include ma_helpers. My dev-folder has highest priority.
//-----------------------------------------------------------------------------------------------------
#local mH = array[2] {"../../misc/ma_helpers/ma_helpers.inc", "ma_helpers.inc" }
#for (mI, 0, dimension_size(mH,1) - 1) #if (file_exists(mH[mI])) #include mH[mI] #end #end #ifndef (MA_Helpers_Temp) #error "Cant find 'ma_helpers.inc'"; #end


// -------------------------------------------------------------------
// Includes needed for screenplay or some of the actors
// -------------------------------------------------------------------

//Most important
#include "ma_screenplay.inc"



// -------------------------------------------------------------------
// Definition of some variables
// -------------------------------------------------------------------

#macro MA_Default()
	#default {
		texture { pigment { color rgb <0.9,0.0,0.5> } }
		finish { ambient 0.1 * LigIntensity diffuse 0.99 }
	}
#end

//#declare LigVector			= <5,5,-10>*100;
#declare LigVector			= <0,10,0>*100;
#declare CamLookAt			= <0,1,0>;
#declare CamLocation		= <0 , 5 ,-15>; //
#declare CamAngle			= 60;
#declare CamSky				= <0,1,0>;
//#declare CamType			= "ultra_wide_angle";


//#declare SCR_FPS			=  0.25;		//Frames per Second. Use small values during development
#declare SCR_FPS			= 2;		//Frames per Second. Use small values during development
#declare SCR_SecondStart	= 0;		//Skip the first x seconds
#declare SCR_SecondEnd		= 60;		//Define the end of the complete script (or end it temporarily earlier)
#declare SCR_SecondFreeze	= 5;		//When no animation gets rendered but a single-picture, render this second

//This looks for Second-Freeze in the cmd-string and overwrites the value above. See --->...................<--- below
//povray +Ima_screenplay_example_docu.pov +O_test/ma_screenplay_1.png +w800 +h600 -GR -A Declare=SCR_CmdFS=1
#ifdef(SCR_CmdFS)
	#declare SCR_SecondFreeze	= SCR_CmdFS;
#end


#declare SWITCH_Testarea	= 1;		//Not part of the Screenplay-Makro. Use s.th. like this to disable things to fasten rendering.


//Here you can place another Set of variables.
//Sometimes its helpfull to have here the real variables to create a high-res animation, without editing all them above
#if (clock_on = 1)

#end

//Dito
#if (0)
	//Do your best
	//#declare SCR_FPS			=  30;
#end



// -----------------------------------------------------------------------------
// -----------------------------------------------------------------------------
// At first register all scenes.
// With two parameters at the moment, name and duration in seconds.
// The name we use later to define what scene the following definitions belong to.
// You can easily change the order of the scenes here,
// no matter when you define the content of the scenes.
// Useless most of the time, but you can do it (yes we can!)
// -----------------------------------------------------------------------------
//-----------------------------------------------------------------------------

#macro SCR_Init ()

	SCR_RegisterScene ("first",		10)
	SCR_RegisterScene ("slopes",	10)
	SCR_RegisterScene ("magic",		10)


	//-------------------------------------------------
	//Take a look inside the array if you like.
	//I have nothing to hide.
	//-------------------------------------------------
	//MA_OutputArrayString      ( SCR_Scenes, "scenes-array.txt", true, "Scenes")


#end


// --------------------------------------------------------------------------------
// --------------------------------------------------------------------------------
// Your private Screenplay-Macro
// This one will called from SCR_Start(), wich in turn you call at the end of this script.
// If you render only one Image, it gets called once.
// If you render a animation, it gets calles for every single frame of every second
// --------------------------------------------------------------------------------
// --------------------------------------------------------------------------------

#macro SCR_Timeline ( mSimulation )

	//-----------------------------------------------------------------------------
	//Pre-dredefine variables.
	//Some of them have to exist to become filled by reference by SCR_FillSceneVarsAll()
	//-----------------------------------------------------------------------------
	#local mSecondAbsolute	= 0;
	#local mSecondStart		= 0;
	#local mSecondEnd		= 0;
	#local mSecond0			= 0;
	#local mSecond1			= 0;
	#local mSecond2			= 0;
	#local mSecond3			= 0;
	
	
	
	
	/*
	
			
		Todos - generell
			- In SetString Slope einfügen, auch wenn erstmal nix mit gemacht wird.
				Evtl später dort was mit machen, z.B. String Buchstabe für Buchstabe erscheinen lassen oder sojet.
				Oder Makro-Parameter an SetValue() anpassen, die jedoch noch nicht geschrieben ist.
			- Für String-Beispiel simple-object Sign oder sojet erstellen
			
		Verschieben? - Für Version 2x aufheben - Nix neues anfangen!
			- Das mit LigIntensity, SetDefault-Makro noch überlegen und abrunden.
			- Cone-Move noch aufteilen? Von 0 bis 5 und danach von 5 bis 10 bisl anders. Um zu zeigen das das auch geht.
			- Überlegen ob den Slope als String über den Kugeln ausgeben (bisl gedreht, hochkant, feste Position)
			- Evtl noch MA_OutputArrayFloat dazubasteln. Oder MA_ArrayConvert_Float2String, wenn wir schon dabei sind.
			
	*/
	

	// ************************************************************************************************************************
	// ************************************************************************************************************************
	//
	// More or less always existing objects
	//
	// ************************************************************************************************************************
	// ************************************************************************************************************************

	//None at the moment
	


	// ************************************************************************************************************************
	// ************************************************************************************************************************
	//
	// Scene 1
	// Simple examples of simple and easy to understand Set*()-macros
	//
	// ************************************************************************************************************************
	// ************************************************************************************************************************

	//------------------------------------------------------
	//Say what scene you like to define
	//------------------------------------------------------
	SCR_SetScene("first")
	
	//------------------------------------------------------
	//Fill automatically some variables you may need.
	//You should not modify SecondStart and SecondEnd.
	//So you can confide that they define the start and end of your scene.
	//But Second 1 to 4 you can/should modify before every SCR_SET*
	//Or use the following macro if you set second 0 to 3 by hand either.
	//SCR_FillSceneVars (mSecondStart, mSecondEnd)
	//------------------------------------------------------
	SCR_FillSceneVarsAll (mSecondStart, mSecondEnd, mSecond0, mSecond1, mSecond2, mSecond3)


	// ************************************************************************************************************************
	//Use a simple number (float) to move the green sphere along the y-axis
	// ************************************************************************************************************************
	#local mName		= "sphere-green";
	#local mProp		= "translate-y";
	#local mValueStart	=  0;
	#local mValueEnd	=  8;
	#local mSecond0		= 0.0;
	#local mSecond1		= 0.0;
	#local mSecond2		= mSecondEnd;
	#local mSecond3		= mSecondEnd;
	//Forget the "" in the middle and the last parameter (1) at the Moment
	SCR_SetNumber	(mName, mProp, mValueStart, mValueEnd, "", mSecond0, mSecond1, mSecond2, mSecond3, 1) 

	
	
	// ************************************************************************************************************************
	// The function SCR_SetNumber() above checks by itself, if the actual to render frame and second is inside the here given timeframe.
	// Like the question: Is it between Second0 and Second3? Then do something
	// If not, it doesnt matter what SCR_SetNumber() has to say, it will be ignored.
	// ************************************************************************************************************************

	//By the way, this is the short version of the 9-liner above
	#if (0)
		SCR_SetNumber	("sphere-green", "translate-y", 0, 8, "", 0, 0, mSecondEnd, mSecondEnd, 1)
	#end
	//By the way 2, this is the the same (SetFloat instead of SetNumber)
	#if (0)
		SCR_SetFloat	("sphere-green", "translate-y", 0, 8, "", 0, 0, mSecondEnd, mSecondEnd, 1)
	#end


	// ************************************************************************************************************************
	// The same you can do with vectors, strings an splines.
	// For that use SCR_SetVector(), SCR_SetString() and ... you wont believe ... SCR_SetSpline()
	// Also the vector can be used for colors.
	// ************************************************************************************************************************


	//-----------------------------------------------------------------------------------------------
	// Use of a vector to change the color
	//-----------------------------------------------------------------------------------------------
	#local mName		= "cylinder-changeling";
	#local mProp		= "color";
	#local mValueStart	= <0,1,1>;
	#local mValueEnd	= <0,0,0>;
	#local mSecond0		= 0.0;
	#local mSecond1		= 2.0;
	#local mSecond2		= 8.0;
	#local mSecond3		= mSecondEnd;
	SCR_SetVector	(mName, mProp, mValueStart, mValueEnd, "", mSecond0, mSecond1, mSecond2, mSecond3, 1)


	//-----------------------------------------------------------------------------------------------
	// Use of a vector to change the position (translate) of the blue cone
	//-----------------------------------------------------------------------------------------------
	#local mName		= "cone-blue";
	#local mProp		= "translate";
	#local mValueStart	= < 5,0,+5>;
	#local mValueEnd	= < 1,2,-5>;
	#local mSecond0		= 0.0;
	#local mSecond1		= 0.0;
	#local mSecond2		= 10.0;
	#local mSecond3		= mSecondEnd;
	SCR_SetVector	(mName, mProp, mValueStart, mValueEnd, "", mSecond0, mSecond1, mSecond2, mSecond3, 1)


	//-----------------------------------------------------------------------------------------------
	// The red box will move to the left and far away AND will rotate around its y-axis.
	//-----------------------------------------------------------------------------------------------
	#local mName		= "box-red";
	#local mProp		= "translate";
	#local mValueStart	= <0,0,-5>;
	#local mValueEnd	= <-5,0,5>;
	#local mSecond0		= 0.0;
	#local mSecond1		= 0.0;
	#local mSecond2		= 8.0;
	#local mSecond3		= mSecondEnd;
	SCR_SetVector	(mName, mProp, mValueStart, mValueEnd, "", mSecond0, mSecond1, mSecond2, mSecond3, 1)
	
	//Here we reuse most of the above declared variables
	#local mProp		= "rotate";
	#local mValueStart	= <0,0,0>;
	#local mValueEnd	= <0,480,0>;
	SCR_SetVector	(mName, mProp, mValueStart, mValueEnd, "", mSecond0, mSecond1, mSecond2, mSecond3, 1)


	//-----------------------------------------------------------------------------------------------
	//The pink sphere will follow a flight-path, defined by a spline
	//-----------------------------------------------------------------------------------------------
	#local mName		= "sphere-pink";
	#local mProp		= "translate";
	#local mValueStart	= <2,3,2>;	
	#local mSplineScene1= spline { // linear_spline | quadratic_spline | cubic_spline | natural_spline
							quadratic_spline
								-0.25, <-5,+1,-3>
								0.00, <+5,+1,-5>
								0.25, <+5,+1,+5>
								0.50, <-5,+4,+4>
								0.55, <-4,+2,+3>
								0.75, <-5,+1,-3>
								1.00, <+5,+1,-5>
								1.25, <+5,+1,+5>
							}
	#local mSecond0		= 0.0;
	#local mSecond1		= 0.0;
	#local mSecond2		= mSecondEnd;
	#local mSecond3		= mSecondEnd;
	SCR_SetSpline	(mName, mProp, mValueStart, mSplineScene1, "", mSecond0, mSecond1, mSecond2, mSecond3, 1)


	//-----------------------------------------------------------------------------------------------
	// Maybe sometimes a vector with 3 floats inside isnt enough.
	// Think about a robotic arm.
	// It maybe can rotate its foot, has three tilt-mechanisms (to tilt 2 arms) and can rotate its head.
	// That are 5 numeric values. You can mis-use a color-vector for it, but believe me, that doesnt make happy.
	// I tried it during nerve-wracking hours ... and the result was SetMixed()
	// Unfortunatly I havent a robotic arm (ready to publish (at the moment)).
	// So for this example we squeeze a few other vectors and floats and so on in one mixed.
	// And use SCR_SetMixed as one-liners to do it.
	//-----------------------------------------------------------------------------------------------

	#local mName		= "not-a-robotic-arm";
	#local mProp		= "everything";
	#local mMixed1		= "+5,+2,-5,  1.0, 1.0, 1.0"; //This are 6 variables in one, in the following lines also
	#local mMixed2		= "-3,+0,+2,  1.0, 0.1, 1.0";
	#local mMixed3		= "+4,+6,+4,  8.0, 1.0, 0.5";
	#local mMixed4		= "+5,+2,-5,  1.0, 1.0, 1.0";
	
	//-----------------------------------------------------------------------------------------------
	// All parameters are the same as above (SetVector and the others)
	// We here use 3 steps the values gets calculated from one to the next.
	//-----------------------------------------------------------------------------------------------
	SCR_SetMixed (mName, mProp, mMixed1, mMixed2, "", 0,0,3,3,1)	//mixed 1 to 2 from second 0 to second 3
	SCR_SetMixed (mName, mProp, mMixed2, mMixed3, "", 3,3,7,7,1)	//mixed 2 to 3 from second 3 to second 7
	SCR_SetMixed (mName, mProp, mMixed3, mMixed4, "", 7,7,10,10,1)	//mixed 3 to 4 till the end



	//------------------------------------------------------------------------------------------------
	// Set a string to display it beneath the scenery
	// SetString() is a littlebit different. It returns ...
	// between second-0 and second-1 => Value1
	// between second-1 and second-2 => Value2
	// between second-2 and second-3 => Value3
	// Maybe the behavior and parameters will change in the future but at the moment its as described.
	//------------------------------------------------------------------------------------------------
	#local mName		= "message";
	#local mProp		= "text";
	#local mValue1		= "first";
	#local mValue2		= concat ("SCR_Second: ", str(SCR_Second, 1, 2)); //displays the actual rendered second
	#local mValue3		= "text deleted";
	#local mSecond0		= 2;
	#local mSecond1		= 3;
	#local mSecond2		= 8;
	#local mSecond3		= 10;
	SCR_SetString	(mName, mProp, mValue1, mValue2, mValue3, mSecond0, mSecond1, mSecond2, mSecond3)

	

	// ************************************************************************************************************************
	// ************************************************************************************************************************
	//
	// Scene 2
	// Slopes
	//
	// ************************************************************************************************************************
	// ************************************************************************************************************************

	//------------------------------------------------------
	//Next Scene!
	//All seconds starts at 0 again.
	//------------------------------------------------------
	SCR_SetScene("slopes")
	SCR_FillSceneVarsAll (mSecondStart, mSecondEnd, mSecond0, mSecond1, mSecond2, mSecond3)


	//---------------------------------------------------------------------------------------------------------------------
	// Here we use all the same parameters for all objects, only the String in the middle differs.
	//
	// It descripes the type of slopes screenplay uses to calculate the new float- or vector-values.
	// In this "slope"-string you can fill up to 3 parameters, separated by ',' or ';'
	// 1. Slope-Type - switch, linear, cosinus, bounce ... and so on. See ma_helpers => MA_GetSlope() for more info
	// 2. number of iterations (1 to x)
	//		where 1 means only the way up from ValueStart to ValueEnd, 2 means up and down, 4 means 2 times up and down.
	//		round numbers means closed loops, nice for 1-scene-animations.
	// 3. offset (0 to 2), this shifts the starting-point of the slope (
	//		0.5 means skip half the way up (from ValueStart to ValueEnd)
	//		1 means we start at ValueEnd and go to ValueStart
	//		2 is the same as 0 (there is a modulo(2) inside the calculating GetSlope()-Macro)
	// Example:
	// - "linear;1;0" - one linear slope
	// - "bounce;3;0.5" - Sinus, 1 and a half times up and down (up-down-up), and skipping of the first quarter
	//---------------------------------------------------------------------------------------------------------------------
	
	#local mProp		= "translate";
	#local mValueStart	= <0,0,0>;
	#local mValueEnd	= <0,5,0>;	//we simply move the spheres along the y-axis, vertical, from the center upwards
	#local mSecond0		= 0.0;
	#local mSecond1		= 0.0;
	#local mSecond2		= mSecondEnd; //We used SCR_RegisterScene() far above to define the length of the scene to 10 seconds, so mSecondEnd = 10.
	#local mSecond3		= mSecondEnd;
	
	SCR_SetVector	("slope-white",		mProp, mValueStart, mValueEnd, "round;2",		mSecond0, mSecond1, mSecond2, mSecond3, 1)
	SCR_SetVector	("slope-green",		mProp, mValueStart, mValueEnd, "linear;2",		mSecond0, mSecond1, mSecond2, mSecond3, 1)
	SCR_SetVector	("slope-red",		mProp, mValueStart, mValueEnd, "cosinus;2",		mSecond0, mSecond1, mSecond2, mSecond3, 1)
	SCR_SetVector	("slope-pink",		mProp, mValueStart, mValueEnd, "cosinus+;2",	mSecond0, mSecond1, mSecond2, mSecond3, 1)
	SCR_SetVector	("slope-blue",		mProp, mValueStart, mValueEnd, "cosinus++;2",	mSecond0, mSecond1, mSecond2, mSecond3, 1)

	SCR_SetVector	("slope-yellow",	mProp, mValueStart, mValueEnd, "bounce+;2",		mSecond0, mSecond1, mSecond2, mSecond3, 1)
	SCR_SetVector	("slope-orange",	mProp, mValueStart, mValueEnd, "bounce-;2;1",	mSecond0, mSecond1, mSecond2, mSecond3, 1)

	SCR_SetVector	("slope-grey-light",mProp, mValueStart, mValueEnd, "linear",		mSecond0, mSecond1, mSecond2, mSecond3, 1)
	SCR_SetVector	("slope-grey-dark",	mProp, mValueStart, mValueEnd, "linear;4;1",	mSecond0, mSecond1, mSecond2, mSecond3, 1)


	//---------------------------------------------------------------------------------------------------------------------
	// Additionally we will move the camera a few units to the left and back.
	// See MA_SetCamAndLight() here in this file and in file ma_helpers why this works.
	//
	// Take care of the last parameter of SCR_SetVector()
	// This one decides, what value gets used after Second3. 0 = mValueStart and 1 = mValueEnd.
	// We are moving the camera to the left AND back (the 2 in "cosinus;2")
	// So we will not see the cam at Position mValueEnd in the last 2 Seconds, otherwise the camera jumps unexpectedly.
	// The last parameter only comes into action if Second2 is smaller than Second3. In this example, it is.
	//---------------------------------------------------------------------------------------------------------------------
	#local mName		= "cam";
	#local mProp		= "location";
	#local mValueStart	= CamLocation;
	#local mValueEnd	= CamLocation + <-3,0,0>;
	#local mSecond0		= 0.0;
	#local mSecond1		= 2.0;
	#local mSecond2		= 8.0;		//smaller than Second3 !
	#local mSecond3		= mSecondEnd;
	SCR_SetVector	(mName, mProp, mValueStart, mValueEnd, "cosinus;2", mSecond0, mSecond1, mSecond2, mSecond3, 0)

	//By the way, outside of mSecond0 and mSecond3 the CamLocation is untouched, whereever defined/declared.
	//There are no left-overs of this functionality here.
	
	
	
	
	
	
	
	
	


	// ************************************************************************************************************************
	// ************************************************************************************************************************
	//
	// Scene 3 - The magic object
	//
	// Now we feed an object, that (later) will look for actions to do by itself.
	// Our magic-object will be a sphere with a box attached to the left and a cylinder to the right.
	// The box at the left can rotate, the cylinder at the right change its length
	// All together they can rotate and move as one object,
	//
	// The screenplay/timeline - what to do when - we have to define here as in the examples above.
	//
	// ************************************************************************************************************************
	// ************************************************************************************************************************

	
	//------------------------------------------------------
	//Set the scene and reset common variables
	//------------------------------------------------------
	SCR_SetScene("magic")
	SCR_FillSceneVarsAll (mSecondStart, mSecondEnd, mSecond0, mSecond1, mSecond2, mSecond3)


	//---------------------------------------------------------------------------------------------------------------------
	// The base- or parent-object is named "magic".
	// We want to move it easy and smooth along the z-axis.
	//
	// Lets use the short way only, this povray-file gets too long.
	// Last Parameter again: false or 0 => use ValueStart after Second2, true or 1 => ValueEnd
	// The name of the property doesnt matter, to move it you can use "translate" or whatever you like
	//---------------------------------------------------------------------------------------------------------------------
	SCR_SetVector	("magic", "move-your-ass", 	<0,2,-5>, <0,2,+5>, "cosinus;2",		0, 2, mSecondEnd - 1, mSecondEnd, false) 
	SCR_SetVector	("magic", "rotate", 		<0,0,0>, <0,-460,0>, "linear",			0, 3, mSecondEnd - 0, mSecondEnd, false) 


	//---------------------------------------------------------------------------------------------------------------------
	// Magic hast two child-objects, "right" and "left" (box and cylinder).
	// If you want to tell the child-objects whats to do, concat the parent-name with their own name by using "/"
	// Lets turn the right object and lengthen the left one.
	// The right one has a sphere on its top named "sphere", that can change its color, does this 3 times (6 divided by 2)
	//---------------------------------------------------------------------------------------------------------------------

	SCR_SetVector	("magic/right",			"spin",	 <0,0,0>, <0,300,0>,"cosinus;3",	0, 1, mSecondEnd - 2,	mSecondEnd, false) 
	SCR_SetVector	("magic/right/sphere",	"color", <0,0,1>, <1,1,0>, 	"linear;6;1",	0, 0, mSecondEnd,		mSecondEnd, false) 
	SCR_SetNumber	("magic/left",			"length", 1, 4,				"cosinus;4",	0, 1, mSecondEnd - 1, 	mSecondEnd, false) 


	//---------------------------------------------------------------------------------------------------------------------
	// Lets have some fun.
	// We will trun on the light at the beginning and turn it off ath the end.
	// Because we are clever and use MA_CameraAndLight_Set() (at the end of the script), so we can do it with one variable.
	// All names and props are NOT case-sensitive, by the way.
	//---------------------------------------------------------------------------------------------------------------------
	SCR_SetNumber	("LIG",			"INTENsitY", 0, 1,				"linear",	0, 0, 2, 2, false) 
	SCR_SetNumber	("LIG",			"INTENsitY", 1, 0,				"linear",	mSecondEnd-2, mSecondEnd-2, mSecondEnd, mSecondEnd, false) 

	//Thats it. Here.









	// ***************************************
	// Output of all the stuff
	// OR ...
	// calling the actors.
	// ***************************************
	
	//--------------------------------------------
	//Finish - Cam and Light-Definition
	//Needed to prepare LigIntensity.
	//See file ma_helpers_v1.inc
	//--------------------------------------------
	MA_CameraAndLight_Prepare()
	


	//--------------------------------------------
	//Scene 1 - simple objects
	//--------------------------------------------

	#if (SCR_GetSceneName() = "first")
		#local mTransY		= SCR_GetFloat ("sphere-green", "", "translate-y",	0);
		//#local mTransY	= SCR_GetNumber ("sphere-green", "", "translate-y",	0); //The same as GetFloat()
		object {
			Simple_Sphere (<0,1,0>)
			translate <-1,mTransY,2>
		}

		#local mColor		= SCR_GetVector ("cylinder-changeling", "", "color",	<1,1,1>);
		object {
			Simple_Cylinder (mColor)
			translate <1,0,-1>
		}

		#local mTrans		= SCR_GetVector ("cone-blue", "", "translate",	<0,0,0>);
		object {
			Simple_Cone (<0,0,1>)
			translate mTrans
		}

		#local mTranslate	= SCR_GetVector ("box-red", "", "translate",	<0,0,0>);
		#local mRotate		= SCR_GetVector ("box-red", "", "rotate",		<0,0,0>);
		object {
			Simple_Box (<1,0,0>)
			rotate		mRotate
			translate	mTranslate
		}
		
		
		//We used SCR_SetSpline far above, but what we like to get is a vector.
		//There is no SCR_GetSpline()-Macro.
		#local mTranslate		= SCR_GetVector ("sphere-pink", "", "translate", <0,0,0>);
		object {
			Simple_Sphere (<1,0,1>) //pink
			translate mTranslate - <0,0.5,0>
		}
		ShowSpline( mSplineScene1, 5000, 0.02, 1)		//Only a small helper to show the complete flight-path with thousands of tiny spheres.
		

		//The mixed
		//Orange sphere thats getting flat and moves wild through the scene.
		//That are 6 parameters in one, 3 for the translate and 3 for scaling.
		#local mName		= "not-a-robotic-arm";
		#local mProp		= "everything";
		
		//Get a Vector out of the mixed-values. Therefore use index 0 to 2 for x,y,z
		//Remember: we used the set-macro like this, with 6 values in it (index from 0 to 5):
		//mMixed1 = "+5,+2,-5, 1.0, 1.0, 1.0";
		#local mTrans	= SCR_GetMixed_Vector (mName, "", mProp,	0, 2, <0,0,0>);
		
		//Another way is to get one float by the other and use them as single values. Important here the numbers 3, 4 and 5
		#local mScaleX	= SCR_GetMixed_Number (mName, "", mProp,	3, 0);	//3rd index = x-value
		#local mScaleY	= SCR_GetMixed_Number (mName, "", mProp,	4, 0);	//4th index = y-value
		#local mScaleZ	= SCR_GetMixed_Float  (mName, "", mProp,	5, 0);	//5th index = z-value - same as GetMixed_Number()
		
		object {
			Simple_Sphere (<1,.3,0>) 
			scale <mScaleX, mScaleY, mScaleZ>	//Using floats
			translate mTrans					//Using vector
		}
		
		//Output the string below the scenery
		#local mString = SCR_GetString ("message", "", "text", "---")
		#local mText = text {
			ttf"timrom.ttf", mString, 0.00015, 0
			texture {
				pigment { color rgb< 0,0,1> }
			}
			no_shadow
			scale 0.5
		}		
		object {
			mText
			translate <-max_extent(mText).x/2,0.8,-8>

			}
		
	
	#end




	//------------------------------------------------------------------------
	//Scene 2 - Slopes
	//This are the jumping spheres to show the different types of slopes.
	//------------------------------------------------------------------------

	#if (SCR_GetSceneName() = "slopes")
		#local mScale = 0.8;
		object { Simple_Sphere (<3,3,3>) scale mScale translate SCR_GetVector ("slope-white",		"", "translate", <0,0,0>) + <-5,0,0> }
		object { Simple_Sphere (<0,1,0>) scale mScale translate SCR_GetVector ("slope-green",		"", "translate", <0,0,0>) + <-4,0,0> }
		object { Simple_Sphere (<1,0,0>) scale mScale translate SCR_GetVector ("slope-red",			"", "translate", <0,0,0>) + <-3,0,0> }
		object { Simple_Sphere (<1,0,1>) scale mScale translate SCR_GetVector ("slope-pink",		"", "translate", <0,0,0>) + <-2,0,0> }
		object { Simple_Sphere (<0,0,1>) scale mScale translate SCR_GetVector ("slope-blue",		"", "translate", <0,0,0>) + <-1,0,0> }

		object { Simple_Sphere (<1,1,0>) scale mScale translate SCR_GetVector ("slope-yellow",		"", "translate", <0,0,0>) + <+1,0,0> }
		object { Simple_Sphere (<1,.2,0>) scale mScale translate SCR_GetVector ("slope-orange",		"", "translate", <0,0,0>) + <+2,0,0> }

		object { Simple_Sphere (<1,1,1>*.7) scale mScale translate SCR_GetVector ("slope-grey-light","", "translate", <0,0,0>) + <+4,0,0> }
		object { Simple_Sphere (<1,1,1>*.2) scale mScale translate SCR_GetVector ("slope-grey-dark", "", "translate", <0,0,0>) + <+5,0,0> }

		//object { Simple_Sphere (<0,1,1>) scale 0.5 translate SCR_GetVector ("slope-cyan",		"", "translate", <0,0,0>) + <-3,0,0> }


	#end


	//--------------------------------------------
	//Scene 3 - The magic object
	//--------------------------------------------

	#if (SCR_GetSceneName() = "magic")

		//The first parameter is the name of the object.
		//About the second you will learn in the macro Magic_Object(), see about 100 lines below.
		#local mParentName	= "";			//We have no parent hier, so let it empty
		#local mName		= "magic";		//Thats the name of the Object (or the name to get infos out of the screenplay-data-array)
		object { Magic_Parent ( mParentName, mName )  }

		//Thats it. Again ... here.


	#end



	//--------------------------------------------
	//Some other stuff
	//--------------------------------------------
	
	#if (SWITCH_Testarea)
		MA_Testarea     (5)
	#end


	sky_sphere {
		pigment { color <0.05,0.05,0.05> * LigIntensity } //LigIntensity to fade-in/out scene 3, gets declared in MA_CameraAndLight_Prepare(), default = 1
	}
	
	
#end 



// -------------------------------------------------------------------
// -------------------------------------------------------------------
// Definition of objects
// In a real animation-file you may include all objects in a separate file
// -------------------------------------------------------------------
// -------------------------------------------------------------------



// -------------------------------------------------------------------
// Simple geometric objects
// Used in all scenes (at the moment)
// All created X and Z centered, Y completely above 0
// -------------------------------------------------------------------


#macro Simple_Sphere (mColor)
	#local mRadius = 0.5;
	#local mResult = sphere {
		<0,0,0> mRadius
		texture {	pigment { color rgb mColor }		}
		finish { ambient 0.1 * LigIntensity diffuse 0.99 }
	}
	object { mResult translate <0,mRadius,0> }
#end

#macro Simple_Box (mColor)
	#local mRadius = 0.5;
	#local mResult = box {
		<-mRadius, 0, -mRadius>
		< mRadius,  mRadius*2,  mRadius>
		texture {	pigment { color rgb mColor }		}
	}
	object { mResult }
#end

#macro Simple_Cylinder (mColor)
	#local mRadius = 0.5;
	#local mHeight = mRadius * 2;
	#local mResult = cylinder {
		<0,0,0>,<0,+mHeight,0>, mRadius
		texture {	pigment { color rgb mColor }		}
	}
	object { mResult }
#end

#macro Simple_Cone (mColor)
	#local mRadius = 0.5;
	#local mHeight = mRadius * 2;
	#local mResult = cone {
		<0,0,0>, mRadius, <0,mHeight,0>, 0
		texture {	pigment { color rgb mColor }		}
	}
	object { mResult }
#end





// -------------------------------------------------------------------
// The magic-object and child-objects
// Objects with built-in screenplay-functionality
// -------------------------------------------------------------------


//For all objects that have screenplay-functionality you should use this 2 parameters at the first ones.
//Even if its the parent-object of all and the second parameter is empty
#macro Magic_Parent ( mParentName, mNewName )

	//Because of that line. You can copy it from one object to the other and have always 2 name-parameters. Saves nerves.
	#local mMyName = SCR_GetName(mParentName, mNewName);

	#local mRadius = 1;

	//The center sphere, the parent-object
	#local mResult = sphere {
		<0,0,0> mRadius
		texture {	pigment { color rgb <1,1,0> transmit 0.5 }		}
		finish { ambient 0.1 * LigIntensity diffuse 0.99 }
	}

	//Add the child-objects at the left and right (which can have child-object also, their choice, see Magic_Right)
	#local mResult = union {
		object { mResult }
		//In this case we use both parameters of the called macro, without concating anything here.
		object { Magic_Right (mMyName, "right") translate <0,mRadius,0> rotate <0,0,-90> }
		object { Magic_Left  (mMyName, "left")  translate <0,mRadius,0> rotate <0,0,+90> }
	}

	//The object is complete, now get the variables for this (the parent-) object and use them
	#local mResult = object {
		mResult
		//MyName, Child-Name, Prop-Name, Default-Value (if nothing was found in the SCR-Arrays)
		rotate		SCR_GetVector (mMyName, "", "rotate",			<0,0,0>)
		translate	SCR_GetVector (mMyName, "", "move-your-ass",	<0,0,0>)
	}
	
	mResult
#end

//The right child-object
//In this case the first parameter is "magic" and the second "right"
#macro Magic_Right ( mParentName, mNewName )

	//Together the name of THIS object is "magic/right"
	#local mMyName = SCR_GetName(mParentName, mNewName);	

	//Create the object
	#local mResult = object {
		Simple_Box (<1,0,0>) 
		//Thats the magic: With mMyName we can look for data in the screenplay-data-array
		//doesnt matter how many parents (grandparents?) it has.
		rotate SCR_GetVector (mMyName, "", "spin", <0,0,0>)
	}
	//Add its child
	#local mResult = union {
		object { mResult }
		object { 
			Magic_Right_Sphere ( mMyName, "sphere" ) //mMyName is "magic/right"
			translate <0,-0.5,0> 	//The object arrives not centered but Y+, so translate it back to center
			translate <0,1,0>		//Move it till half of the sphere lies outside of the parent box
		}
	}
	mResult
#end

//The child-object of the child-object "magic/right"
//This one here will have the mMyName = "magic/right/sphere"
#macro Magic_Right_Sphere ( mParentName, mNewName )
	#local mMyName = SCR_GetName(mParentName, mNewName);	

	//Its a simple sphere which can change its color.
	#local mResult = object {
		Simple_Sphere (SCR_GetVector (mMyName, "", "color", <0,0,0>))
	}
	mResult
#end

//The left child-object (that has no own childs)
#macro Magic_Left ( mParentName, mNewName )
	#local mMyName = SCR_GetName(mParentName, mNewName);
	
	#local mResult = object {
		
		//Get a green cylinder
		Simple_Cylinder (<0,1,0>)
		
		//Get variable
		#local mLength = SCR_GetNumber (mMyName, "", "length", 1);
		
		//scale it. Make it littlebit more thin too.
		scale <0.5,mLength,0.5>
		
	}
	
	mResult
#end


// -------------------------------------------------------------------
// Fast and dirty way to display the path of a spline.
// Used in scene 1.
// -------------------------------------------------------------------
#macro ShowSpline ( mSpline, mSteps, mRadius, mScale )
	#for (mIndex, 0, 1, 1 / mSteps)
		#local mVector = mSpline (mIndex) * mScale;
		sphere { mVector mRadius
			texture		{ 	pigment { color rgb <1,1,0> } }
		}
	#end
#end





//--------------------------------
// Thats the end.
//--------------------------------

//Execute Screenplay
SCR_Start()

//Finally sets camera and light
MA_CameraAndLight_Set()

//Send some statistics to the terminal (optional)
MA_Finish()







