/*

+GD +GF -GR +GS +GW +Q9

povray +Ima_screenplay_example7_tussi.pov +Otest/test7.png +w400 +h300 -GR -A Declare=SCR_CmdFS=1
povray +Ima_screenplay_example7_tussi.pov +Otest/test7.png +w640 +h360 -GR -A Declare=SCR_CmdFS=1
povray +Ima_screenplay_example7_tussi.pov +Otest/test7.png +w800 +h600 -GR -A Declare=SCR_CmdFS=1
povray +Ima_screenplay_example7_tussi.pov +Otest/test7.png +w1280 +h720 -GR +A  Declare=SCR_CmdFS=45.1
povray +Ima_screenplay_example7_tussi.pov +Otest/test7.png +w1280 +h720 -GR +A  Declare=SCR_CmdFS=25
povray +Ima_screenplay_example7_tussi.pov +Otest/test7.png +w1920 +h1080 -GR +A  Declare=SCR_CmdFS=47

povray +Ima_screenplay_example7_tussi.pov +Otest/test7.png +w1280 +h720 -GR +A  Declare=SCR_CmdFS=2


//The script aboarts itself when the last image was rendered, so use high numbers for +KFF
povray +Ima_screenplay_example7_tussi.pov +Oanim7/anim0- +w400  +h225 -GR -A +KFI0 +KFF10000
povray +Ima_screenplay_example7_tussi.pov +Oanim7/anim0- +w600  +h360 -GR -A +KFI0 +KFF10000
povray +Ima_screenplay_example7_tussi.pov +Oanim7/anim0- +w800  +h600 -GR -A +KFI0 +KFF10000
povray +Ima_screenplay_example7_tussi.pov +Oanim7/anim0- +w1000 +h750 -GR +A +KFI0 +KFF10000
povray +Ima_screenplay_example7_tussi.pov +Oanim7/anim0- +w1200 +h600 -GR +A +KFI0 +KFF10000

Asus (my tablet)
povray +Ima_screenplay_example7_tussi.pov +Oanim7/anim0- +w1280 +h800 -GR +A +KFI0 +KFF10000
HD
povray +Ima_screenplay_example7_tussi.pov +Oanim7/anim0- +w1280 +h720 -GR +A +KFI0 +KFF10000
3/4 -HD
povray +Ima_screenplay_example7_tussi.pov +Oanim7/anim0- +w960 +h540 -GR -A +KFI0 +KFF10000
Half-HD
povray +Ima_screenplay_example7_tussi.pov +Oanim7/anim0- +w640 +h360 -GR -A +KFI0 +KFF10000


file:///home/pi/Projekte/povray/packages-ma/misc/ma_screenplay/test/

--------------------------------------------------------
Convert results into movies
%04d stands for number of digits in picture-names
pic000.png  - pic150.png  => %03d
pic0000.png - pic0800.png => %04d
-r 10 => 10 FPS
--------------------------------------------------------
ffmpeg -r 10 -f image2 -i anim7/anim0-%05d.png -y -vcodec libx264 -crf 25  -pix_fmt yuv420p anim7/anim0.mp4
ffmpeg -r  5 -f image2 -i anim7/anim0-%05d.png -y -vcodec libx264 -crf 25  -pix_fmt yuv420p anim7/anim0.mp4
ffmpeg -r 30 -f image2 -i anim7/anim0-%05d.png -y -vcodec libx264 -crf 23  -pix_fmt yuv420p anim7/anim0.mp4

--------------------------------------------------------
Convert results into animgifs
-delay x  => NOT FPS but delay in deci-seconds!
-delay 5  => 20 FPS
-delay 25 => 4  FPS
--------------------------------------------------------
convert -delay 20 anim2/anim0-*.png anim2/anim0_x.gif
convert -delay 10 anim2/anim0-*.png anim2/anim0_x.gif


--------------------------------------------------------
Deletes the previous rendered pictures
Handle with care
--------------------------------------------------------
rm anim7/anim0-*.png

*/


// -------------------------------------------------------------------
// Start of file and common povray-stuff
// -------------------------------------------------------------------

#version 3.7;

global_settings		{
	assumed_gamma 1.0
	charset utf8
}
#default {
	texture { pigment { color rgb <0.9,0.0,0.5> } }
	finish { ambient 0.1 diffuse 0.99 }
}

#include "colors.inc"
#include "textures.inc"



//-----------------------------------------------------------------------------------------------------
//Try to include ma_helpers. My dev-folder has highest priority.
//-----------------------------------------------------------------------------------------------------
#local mH = array[2] {"../../misc/ma_helpers/ma_helpers.inc", "ma_helpers.inc" }
#for (mI, 0, dimension_size(mH,1) - 1) #if (file_exists(mH[mI])) #include mH[mI] #end #end #ifndef (MA_Helpers_Temp) #error "Cant find 'ma_helpers.inc'"; #end



// -------------------------------------------------------------------
// Includes needed for screenplay or some of the actors
// -------------------------------------------------------------------

//-----------------------------------------------
//Include Skyfakes for some nice backgrounds
//-----------------------------------------------
//#declare MA_Include_Talk = 1;		// 1 = sends some debug-messages to the terminal, 0 doesnt.
#declare mFolderSkyfakes = MA_Include("ma_skyfakes.inc", "");
#if (mFolderSkyfakes != "-1")
	MA_Terminal("Skyfakes found")
	#include concat(mFolderSkyfakes, "ma_skyfakes_textures.inc")
#else
	MA_Terminal("Skyfakes NOT found")
#end
#local mFolderTussi = MA_Include("ma_tussi.inc", "");
#if (mFolderTussi != "-1")
	MA_Terminal("Tussi found")
#else
	MA_Terminal("Tussi NOT found")
#end


//Most important
#include "ma_screenplay.inc"


/*
#declare BasePath = "../../";

#include concat(BasePath, "misc/ma_helpers/ma_helpers.inc")
#include concat(BasePath, "astro/ma_skyfakes/ma_skyfakes.inc")
#include concat(BasePath, "astro/ma_skyfakes/ma_skyfakes_textures.inc")
#include concat(BasePath, "space/ma_tussi/ma_tussi.inc")

*/


// -------------------------------------------------------------------
// Definition of some variables
// -------------------------------------------------------------------

#macro MA_Default()
	#default {
		texture { pigment { color rgb <0.9,0.0,0.5> } }
		finish { ambient 0.005 * LigIntensity diffuse 0.99 }
	}
#end

//#declare LigVector			= <5,5,-10>*100;
#declare LigVector			= <5,10,-5>*1000;
#declare CamLookAt			= <0,1,0>;
#declare CamLocation		= <1 , 5 ,-15>; //
#declare CamAngle			= 60;
#declare CamSky				= <0,1,0>;
//#declare CamType			= "ultra_wide_angle";


// -------------------------------------------------------------------
// Definition of screenplay-variables
// -------------------------------------------------------------------


#declare SCR_FPS			= 1.0;		//Frames per Second. Use small values during development
#declare SCR_SecondStart	= 0;		//Skip the first x seconds
#declare SCR_SecondEnd		= 85;		//Define the end of the complete script (or end it temporarily earlier). To play it complete you can use 9999 or so.
#declare SCR_SecondFreeze	= 0;		//When rendering no animation but a single-picture, render this second

//This looks for Second-Freeze in the cmd-string and overwrites the value above. See ----->...................<--- below
//povray +Ima_screenplay_example2_tussi.pov +O_test/ma_screenplay_2.png +w800 +h600 -GR -A Declare=SCR_CmdFS=1
#ifdef(SCR_CmdFS)
	#declare SCR_SecondFreeze	= SCR_CmdFS;
#end


//Here you can place another Set of variables.
//Sometimes its helpfull to have here the real variables to create a high-res animation, without editing all them above
#if (clock_on = 1)

#end

//Ditto
#if (0)
	//Do your best
	//#declare SCR_FPS			=  30;
#end




// -----------------------------------------------------------------------------
// -----------------------------------------------------------------------------
// At first register all scenes.
// With two parameters at the moment, name and duration in seconds.
// The name we use later to define what scene the following definitions belong to.
// You can easily change the order of the scenes here,
// no matter when you define the content of the scenes.
// Useless most of the time, but you can do it (yes we can!)
// -----------------------------------------------------------------------------
//-----------------------------------------------------------------------------

#macro SCR_Init ()

	SCR_RegisterScene ("launch",		20)
	SCR_RegisterScene ("leo",			20)
	SCR_RegisterScene ("transit",		10)
	SCR_RegisterScene ("pre-landing",	10)
	SCR_RegisterScene ("landing",		25)


#end

// --------------------------------------------------------------------------------
// --------------------------------------------------------------------------------
// Your private Screenplay-Macro
// This one will called from SCR_Start(), which in turn you call at the end of this script.
// If you render only one Image, it gets called once.
// If you render a animation, it gets calles for every single frame of every second
// --------------------------------------------------------------------------------
// --------------------------------------------------------------------------------

#macro SCR_Timeline ( mSimulation )

	//-----------------------------------------------------------------------------
	//Pre-dredefine variables.
	//Some of them have to exist to become filled by reference by SCR_FillSceneVarsAll()
	//-----------------------------------------------------------------------------
	#local mSecondAbsolute	= 0;
	#local mSecondStart		= 0;
	#local mSecondEnd		= 0;
	#local mSecond0			= 0;
	#local mSecond1			= 0;
	#local mSecond2			= 0;
	#local mSecond3			= 0;
	

	// ************************************************************************************************************************
	// ************************************************************************************************************************
	//
	// Always or most of the time visible elements
	// Defined before all scenes the values from and till are absolute values, 10 and 80 means from second 10 to second 80.
	// But dont forget to modify this if you change the order of the scenes (above).
	//
	// ************************************************************************************************************************
	// ************************************************************************************************************************

	SCR_SetMarker ("stars",	10, 999)	//Stars will be visible from second 10 till the end, no matter what scene it is.

	
	
	

	// ************************************************************************************************************************
	// ************************************************************************************************************************
	//
	// Scene 1 - Launch from Earth
	//
	// ************************************************************************************************************************
	// ************************************************************************************************************************

	//------------------------------------------------------
	//Start the work on the first scene
	//Use the name as registered above.
	//------------------------------------------------------
	SCR_SetScene("launch")
	
	//------------------------------------------------------
	//Fill automatically some variables you may need.
	//You should not modify SecondStart and SecondEnd.
	//So you can confide that they define the start and end of your scene.
	//But Second 1 to 4 you can/should modify before every SCR_SET*
	//Or use this if you set second 0 to 3 by hand either.
	//SCR_FillSceneVars (mSecondStart, mSecondEnd)
	//------------------------------------------------------
	SCR_FillSceneVarsAll (mSecondStart, mSecondEnd, mSecond0, mSecond1, mSecond2, mSecond3)
	

	//------------------------------------------------------
	//All Engines running and acceleration of Tussi at once
	//------------------------------------------------------
	#local mProp		= "active";
	#local mValueStart	=   0;
	#local mValueEnd	=   1;
	#local mSecond0		= 0.0;
	#local mSecond1		= 2.0;
	#local mSecond2		= mSecondEnd;
	#local mSecond3		= mSecondEnd;
	SCR_SetNumber ("tussi/engine",		mProp, mValueStart, mValueEnd, "bool", mSecond0, mSecond1, mSecond2, mSecond3, 1)
	SCR_SetNumber ("tussi/booster1",	mProp, mValueStart, mValueEnd, "bool", mSecond0, mSecond1, mSecond2, mSecond3, 1)
	SCR_SetNumber ("tussi/booster2",	mProp, mValueStart, mValueEnd, "bool", mSecond0, mSecond1, mSecond2, mSecond3, 1)
	SCR_SetNumber ("tussi/booster3",	mProp, mValueStart, mValueEnd, "bool", mSecond0, mSecond1, mSecond2, mSecond3, 1)
	SCR_SetNumber ("tussi/booster4",	mProp, mValueStart, mValueEnd, "bool", mSecond0, mSecond1, mSecond2, mSecond3, 1)

	#local mName		= "tussi";
	#local mProp		= "translate";
	#local mValueStart	=   <0, 0, 0>;
	#local mValueEnd	=   <0, 500, 0>;
	SCR_SetVector (mName, mProp, mValueStart, mValueEnd, "linear", mSecond0, mSecond1, mSecond2, mSecond3, 1)


	//------------------------------------------------------
	//Camera follows Tussi
	//------------------------------------------------------
	#local mTussiTranslate = SCR_GetVector ("tussi", "", "translate",	<0,0,0>); //Get the position of Tussi, defined few lines above.
	SCR_SetVector ("cam", "location", <1 , 5 ,-25>, <1 , 5 ,-25>, "linear", mSecond0, mSecond1, mSecond2, mSecond3, 1)
	SCR_SetVector ("cam", "lookat", mTussiTranslate + <0,4,0>, mTussiTranslate, "linear", mSecond0, mSecond1, mSecond2, mSecond3, 1)
	SCR_SetNumber ("cam", "angle", 60, 60, "linear", mSecond0, mSecond1, mSecond2, mSecond3, 1) //Zoom in or out, as you like.

	//------------------------------------------------------
	//Rotate the clouds a littlebit
	//Only in the first seconds, when camera is located at the surface
	//------------------------------------------------------
	SCR_SetNumber ("clouds", "rotate", 0,1, "linear", 0, 0, 8, 8, 1)


	//------------------------------------------------------
	//After a while camera flies side by side with tussi
	//This new value for location overwrites them above from second 8 on
	//------------------------------------------------------
	#local mSecond0		= 8.0;
	#local mSecond1		= 8.0;
	#local mSecond2		= mSecondEnd;
	#local mSecond3		= mSecondEnd;
	#local mTussiTranslate = SCR_GetVector ("tussi", "", "translate",	<0,0,0>) + <0,0,-50>; //Z-axis offset, Tussi is a bit faster.
	SCR_SetVector ("cam", "location", mTussiTranslate + <0,10,0>, mTussiTranslate  + <0,-20,0>, "linear", mSecond0, mSecond1, mSecond2, mSecond3, 1)
	//SCR_SetNumber ("cam", "angle", 60, 80, "linear", mSecond0, mSecond1, mSecond2, mSecond3, 1)


	//------------------------------------------------------
	//Dim the blue background-sky
	//Shows transition from inside atmosphere to free space
	//------------------------------------------------------
	#local mSecond0		= 8.0;
	#local mSecond1		= 8.0;
	#local mSecond2		= mSecondEnd-2;
	#local mSecond3		= mSecondEnd;
	SCR_SetNumber ("bluesky", "transmit", 0, 1, "linear", mSecond0, mSecond1, mSecond2, mSecond3, 1)


	//------------------------------------------------------
	//Meanwhile pull in all landing-legs
	//------------------------------------------------------
	#local mSecond0		= 8.0;
	#local mSecond1		= 8.0;
	#local mSecond2		= 11;
	#local mSecond3		= mSecondEnd;
	SCR_SetNumber ("tussi/leg1", "stretched", 1, 0, "linear", mSecond0, mSecond1, mSecond2, mSecond3, 1)
	SCR_SetNumber ("tussi/leg2", "stretched", 1, 0, "linear", mSecond0, mSecond1, mSecond2, mSecond3, 1)
	SCR_SetNumber ("tussi/leg3", "stretched", 1, 0, "linear", mSecond0, mSecond1, mSecond2, mSecond3, 1)
	SCR_SetNumber ("tussi/leg4", "stretched", 1, 0, "linear", mSecond0, mSecond1, mSecond2, mSecond3, 1)

	//--------------------------------------------------------------------
	//... and separate boosters shortly after
	//Process starts at value = -10, the flame gets shorter and shorter
	//Separation at 0, distance and rotation grows over time.
	//The whole process is a built-in of Tussi.
	//--------------------------------------------------------------------
	#local mValueStart	= -10;
	#local mValueEnd	= 20;
	#local mSecond0		= 10.0;
	#local mSecond1		= 10.0;
	#local mSecond2		= mSecondEnd;
	#local mSecond3		= mSecondEnd;
	#local mProp		= "separation";
	
	SCR_SetNumber ("tussi/booster1", mProp, mValueStart, mValueEnd, "linear", mSecond0, mSecond1+1,	mSecond2+1,	mSecond3, 1)
	SCR_SetNumber ("tussi/booster2", mProp, mValueStart, mValueEnd, "linear", mSecond0, mSecond1,	mSecond2,	mSecond3, 1)
	SCR_SetNumber ("tussi/booster3", mProp, mValueStart, mValueEnd, "linear", mSecond0, mSecond1+1,	mSecond2+1,	mSecond3, 1)
	SCR_SetNumber ("tussi/booster4", mProp, mValueStart, mValueEnd, "linear", mSecond0, mSecond1,	mSecond2,	mSecond3, 1)



	// ************************************************************************************************************************
	// ************************************************************************************************************************
	//
	// Scene 2
	// Tussi in LEO, orienting itself, unfold solarcells and starts cruise to the moon
	//
	// ************************************************************************************************************************
	// ************************************************************************************************************************

	//-----------------------------------------------------------------------------
	//Start the scene
	//Absolute it is second 20, but with SetScene() we can start at second 0 again.
	//-----------------------------------------------------------------------------
	SCR_SetScene("leo")
	SCR_FillSceneVarsAll (mSecondStart, mSecondEnd, mSecond0, mSecond1, mSecond2, mSecond3)


	//------------------------------------------------------
	//Let the horizon and stars rotate a tiny bit
	//------------------------------------------------------
	SCR_SetVector ("horizon",	"rotate",	<0,0,0>, <0,0.4,0>,	"linear", 0, 0, mSecondEnd, mSecondEnd, 0)
	SCR_SetVector ("stars",		"rotate",	<0,0,0>, <0,10,0>,	"linear", 0, 0, mSecondEnd, mSecondEnd, 0)

	//------------------------------------------------------
	//Unfold Solarcells and rotate them
	//------------------------------------------------------
	SCR_SetNumber ("tussi", "sc-angle",	0, 90, "cosinus",		0, 3,	7,	mSecondEnd, 1)	//unfold
	SCR_SetNumber ("tussi", "sc-tilt",	0, 190, "cosinus++",	0, 5,	10,	mSecondEnd, 1)	//rotate


	//------------------------------------------------------
	//Rotate Tussi in the right direction for TLI
	//(Trans Lunar Injection)
	//------------------------------------------------------
	#local mRotate1 = <0,0,-90>;
	#local mRotate2 = <+90,0,-90>;
	#local mSecondRotStart = 3;
	#local mSecondRotEnd = 8;
	SCR_SetVector ("tussi", "rotate", mRotate1, mRotate2, "cosinus", 0, mSecondRotStart, mSecondRotEnd, mSecondEnd, 1)

	//------------------------------------------------------------------------------------------------------------
	//Around RotStart and RotEnd activate the small thrusters.
	//Ony by one, sorry.
	//Example: in the first linke "tb-ft/tl" stands for ...
	//tb => Thruster-Box (each containing 4 thrusters), there are 8 ones mounted on Tussi (= 32 thrusters).
	//ft => "f" = forward-mounted on the top (f = forward, a = aft, looking from the side, standing Tussi)
	//		"t" = top (top, bottom, left, right), think about a Tussi lying flat on the surface, rotated +90 around X axis.
	//tl => thruster left (right, left, away, upward) ...
	// 		Think about the direction of the flame, seen from inside Tussi, looking at the Box, with their mounting-plate at the bottom.
	//Not easy to understand, I know, its on my list.
	//Yes indeed, there is an ACS (Attitude Control System) under construction that will become easier to talk with.
	//By the way: These are pulsed thrusters, flaming every 2nd frame only.
	//------------------------------------------------------------------------------------------------------------
	
	//Thrusters during START of rotation.
	SCR_SetVector ("tussi/tb-ft/tl", "active", 0, 1, "bool", mSecondRotStart, mSecondRotStart, mSecondRotStart + 2, mSecondRotStart + 2, 1)
	SCR_SetVector ("tussi/tb-fr/tu", "active", 0, 1, "bool", mSecondRotStart, mSecondRotStart, mSecondRotStart + 2, mSecondRotStart + 2, 1)
	SCR_SetVector ("tussi/tb-fb/tr", "active", 0, 1, "bool", mSecondRotStart, mSecondRotStart, mSecondRotStart + 2, mSecondRotStart + 2, 1)
	SCR_SetVector ("tussi/tb-at/tl", "active", 0, 1, "bool", mSecondRotStart, mSecondRotStart, mSecondRotStart + 2, mSecondRotStart + 2, 1)
	SCR_SetVector ("tussi/tb-al/tu", "active", 0, 1, "bool", mSecondRotStart, mSecondRotStart, mSecondRotStart + 2, mSecondRotStart + 2, 1)
	SCR_SetVector ("tussi/tb-ab/tr", "active", 0, 1, "bool", mSecondRotStart, mSecondRotStart, mSecondRotStart + 2, mSecondRotStart + 2, 1)

	//Thrusters during END of rotation
	SCR_SetVector ("tussi/tb-at/tr", "active", 0, 1, "bool", mSecondRotEnd - 2, mSecondRotEnd - 2, mSecondRotEnd, mSecondRotEnd, 1)
	SCR_SetVector ("tussi/tb-ar/tu", "active", 0, 1, "bool", mSecondRotEnd - 2, mSecondRotEnd - 2, mSecondRotEnd, mSecondRotEnd, 1)
	SCR_SetVector ("tussi/tb-ab/tl", "active", 0, 1, "bool", mSecondRotEnd - 2, mSecondRotEnd - 2, mSecondRotEnd, mSecondRotEnd, 1)
	SCR_SetVector ("tussi/tb-ft/tr", "active", 0, 1, "bool", mSecondRotEnd - 2, mSecondRotEnd - 2, mSecondRotEnd, mSecondRotEnd, 1)
	SCR_SetVector ("tussi/tb-fl/tu", "active", 0, 1, "bool", mSecondRotEnd - 2, mSecondRotEnd - 2, mSecondRotEnd, mSecondRotEnd, 1)
	SCR_SetVector ("tussi/tb-fb/tl", "active", 0, 1, "bool", mSecondRotEnd - 2, mSecondRotEnd - 2, mSecondRotEnd, mSecondRotEnd, 1)



	//------------------------------------------------------
	//Start Tussi-rotation to stabalize the upcomming engine-burn
	//For that rorate Tussi and at the begining activate thrusters
	//------------------------------------------------------
	#local mRotate1 = mRotate2;	//the value from above
	#local mRotate2 = mRotate1 + <0,0,-360*1.5>; //final rotation, till the end of the scene!
	#local mSecondRotStart = 9;
	SCR_SetVector ("tussi", "rotate", mRotate1, mRotate2, "linear", mSecondRotStart, mSecondRotStart, mSecondEnd, mSecondEnd, 1)

	//Thrusters during START of rotation
	#local mStart	= mSecondRotStart - 0.5;
	#local mEnd		= mSecondRotStart + 0.5;
	SCR_SetVector ("tussi/tb-ft/tr", "active", 0, 1, "bool", mStart, mStart, mEnd, mEnd, 1)
	SCR_SetVector ("tussi/tb-fb/tr", "active", 0, 1, "bool", mStart, mStart, mEnd, mEnd, 1)
	SCR_SetVector ("tussi/tb-at/tl", "active", 0, 1, "bool", mStart, mStart, mEnd, mEnd, 1)
	SCR_SetVector ("tussi/tb-ab/tl", "active", 0, 1, "bool", mStart, mStart, mEnd, mEnd, 1)
	
	
	//------------------------------------------------------
	//At the end activate engine and move Tussi away
	//------------------------------------------------------
	#local mSecond1 = 12;
	#local mLocation1 = <0,0,0>;
	#local mLocation2 = <0,0,700>;
	SCR_SetVector ("tussi", "translate", mLocation1, mLocation2, "bounce-",	0, mSecond1, mSecondEnd, mSecondEnd, 1)
	SCR_SetNumber ("tussi/engine", "active", 0, 1, "bool",				0, mSecond1,mSecondEnd, mSecondEnd, 1)


	//------------------------------------------------------
	//At the very end maybe Tussi casts a shadow on earth,
	//so hide the shadow when tussi is to small to show shadows on itself
	//This function isnt buildt in, do it manually
	//We have to do this as late as possible,
	//because no_shadow means no shadows on Earth
	//AND on Tussi itself (by the solarsells)
	//------------------------------------------------------
	#local mStart = 18; //tests only, shadow visible for about 1 second, come into view from the left
	#local mStart = 14;	//Tussi far enough away
	SCR_SetNumber ("tussi", "hide-shadow", 0.1, 1, "linear", mStart, mStart ,mSecondEnd, mSecondEnd, 1)


	//------------------------------------------------------
	//Camera follows Tussi
	//Also move slightly its position, looks better than totally fixed.
	//------------------------------------------------------
	#local mTussiTranslate = SCR_GetVector ("tussi", "", "translate",	<0,0,0>); //Get the position of Tussi, defined somewhere above.
	SCR_SetVector ("cam", "lookat", mTussiTranslate, mTussiTranslate, "linear", mSecondStart, mSecondStart, mSecondEnd, mSecondEnd, 1)
	#local mLocation1 = <15 , 5 ,-25>;
	#local mLocation2 = <10 , -5 ,-20>;
	SCR_SetVector ("cam", "location", mLocation1, mLocation2, "linear", mSecondStart, mSecondStart, mSecondEnd, mSecondEnd, 1)



	// ************************************************************************************************************************
	// ************************************************************************************************************************
	//
	// Scene 3 - Flight to the target - my favorit scene :)
	//
	// ************************************************************************************************************************
	// ************************************************************************************************************************

	//------------------------------------------------------
	//Start the scene
	//------------------------------------------------------
	SCR_SetScene("transit")
	SCR_FillSceneVarsAll (mSecondStart, mSecondEnd, mSecond0, mSecond1, mSecond2, mSecond3)
	

	//------------------------------------------------------
	//Light and Sun (position the visible Sun later/below)
	//------------------------------------------------------
	SCR_SetVector ("lig", "vector", <0,0,-1000000>, <0,0,-1000000>, "linear", 0,0, mSecondEnd, mSecondEnd, 1)
	SCR_SetMarker ("sun", 0, mSecondEnd)
	
	//------------------------------------------------------
	//Move Tussi and set rotate
	//------------------------------------------------------
	#local mRotStart		= <0,-45,-90>;	//-45 because of slightly off-axis mounted solarcells.
	#local mRotEnd			= <0,-45,-90>;	//modify the Y-value if you like to see her rotate
	#local mSecondEnd1st	= 10;			//aehm ... dont know exactly why this exist (beside the standard mSecondEnd), will check it later.
	#local mLocation1		= <-700,0,0>;
	#local mLocation2		= <+700,0,0>;
	SCR_SetVector ("tussi", "translate",mLocation1, mLocation2,	"linear", 0,0, mSecondEnd1st, mSecondEnd1st, 1)
	SCR_SetVector ("tussi", "rotate",	mRotStart, mRotEnd,		"linear", 0,0, mSecondEnd1st, mSecondEnd1st, 1)

	//------------------------------------------------------
	//Let Earth and Moon rotate a tiny bit
	//Both are visible only half the time
	//------------------------------------------------------
	SCR_SetVector ("earth", "rotate", <0,0,0>, <0,-20,0>, "linear", 0,0, mSecondEnd/2, mSecondEnd/2, 1)
	SCR_SetVector ("moon",  "rotate", <0,0,0>, <0,-20,0>, "linear", mSecondEnd/2, mSecondEnd/2, mSecondEnd, mSecondEnd, 1)
	
	//------------------------------------------------------
	//Camera looks at Tussi, moving at lower speed
	//------------------------------------------------------
	#local mTussiTranslate = SCR_GetVector ("tussi", "", "translate",	<0,0,0>);
	#local mCamLocation	= mTussiTranslate / 4 + <0,5,+50>;
	SCR_SetVector ("cam", "location",	mCamLocation,	mCamLocation,	"linear", 0,mSecond1, mSecondEnd1st, mSecondEnd1st, 1)
	SCR_SetVector ("cam", "lookat", mTussiTranslate, mTussiTranslate, "linear", mSecondStart, mSecondStart, mSecondEnd1st, mSecondEnd1st, 1)



	// ************************************************************************************************************************
	// ************************************************************************************************************************
	//
	// Scene 4 - Preparing for Landing
	//
	// ************************************************************************************************************************
	// ************************************************************************************************************************

	//------------------------------------------------------
	//Start the scene
	//------------------------------------------------------
	SCR_SetScene("pre-landing")
	SCR_FillSceneVarsAll (mSecondStart, mSecondEnd, mSecond0, mSecond1, mSecond2, mSecond3)
	


	//------------------------------------------------------
	//Translate and rotate Tussi
	//------------------------------------------------------
	//#local mRotate1 = <180,+45,-90>;
	//#local mRotate2 = <360,+45,-90>;
	#local mRotate1			= <180,0,-90>;
	#local mRotate2			= <360,0,-90>;
	#local mSecondRotStart	= 3;
	#local mSecondRotEnd	= 8;
	SCR_SetVector ("tussi", "rotate", mRotate1, mRotate2, "cosinus", 0, mSecondRotStart, mSecondRotEnd, mSecondEnd, 1)
	SCR_SetVector ("tussi", "translate", <1,0,0>, <-1,0,0>, "linear", 0, 0, mSecondEnd, mSecondEnd, 1)

	//------------------------------------------------------
	//Around RotStart and RotEnd activate the small thrusters
	//Ony by one, sorry, will try to better this later.
	//Tussi isnt perfect at all.
	//------------------------------------------------------
	
	//Thrusters during START of rotation
	SCR_SetVector ("tussi/tb-ft/tl", "active", 0, 1, "bool", mSecondRotStart, mSecondRotStart, mSecondRotStart + 2, mSecondRotStart + 2, 1)
	SCR_SetVector ("tussi/tb-fr/tu", "active", 0, 1, "bool", mSecondRotStart, mSecondRotStart, mSecondRotStart + 2, mSecondRotStart + 2, 1)
	SCR_SetVector ("tussi/tb-fb/tr", "active", 0, 1, "bool", mSecondRotStart, mSecondRotStart, mSecondRotStart + 2, mSecondRotStart + 2, 1)
	SCR_SetVector ("tussi/tb-at/tl", "active", 0, 1, "bool", mSecondRotStart, mSecondRotStart, mSecondRotStart + 2, mSecondRotStart + 2, 1)
	SCR_SetVector ("tussi/tb-al/tu", "active", 0, 1, "bool", mSecondRotStart, mSecondRotStart, mSecondRotStart + 2, mSecondRotStart + 2, 1)
	SCR_SetVector ("tussi/tb-ab/tr", "active", 0, 1, "bool", mSecondRotStart, mSecondRotStart, mSecondRotStart + 2, mSecondRotStart + 2, 1)

	//Thrusters during END of rotation
	SCR_SetVector ("tussi/tb-at/tr", "active", 0, 1, "bool", mSecondRotEnd - 2, mSecondRotEnd - 2, mSecondRotEnd, mSecondRotEnd, 1)
	SCR_SetVector ("tussi/tb-ar/tu", "active", 0, 1, "bool", mSecondRotEnd - 2, mSecondRotEnd - 2, mSecondRotEnd, mSecondRotEnd, 1)
	SCR_SetVector ("tussi/tb-ab/tl", "active", 0, 1, "bool", mSecondRotEnd - 2, mSecondRotEnd - 2, mSecondRotEnd, mSecondRotEnd, 1)
	SCR_SetVector ("tussi/tb-ft/tr", "active", 0, 1, "bool", mSecondRotEnd - 2, mSecondRotEnd - 2, mSecondRotEnd, mSecondRotEnd, 1)
	SCR_SetVector ("tussi/tb-fl/tu", "active", 0, 1, "bool", mSecondRotEnd - 2, mSecondRotEnd - 2, mSecondRotEnd, mSecondRotEnd, 1)
	SCR_SetVector ("tussi/tb-fb/tl", "active", 0, 1, "bool", mSecondRotEnd - 2, mSecondRotEnd - 2, mSecondRotEnd, mSecondRotEnd, 1)

	//------------------------------------------------------
	//Meanwhile fold Solarcells
	//------------------------------------------------------
	SCR_SetNumber ("tussi", "sc-tilt",	90, 0, "cosinus",	0, 1, 5,	mSecondEnd, 1)
	SCR_SetNumber ("tussi", "sc-angle",	90, 0, "cosinus",	0, 3, 7,	mSecondEnd, 1)


	//------------------------------------------------------
	//At the end activate engine
	//------------------------------------------------------
	#local mSecond1 = 8.5;
	SCR_SetNumber ("tussi/engine", "active", 0, 1, "bool", 0, mSecond1,mSecondEnd, mSecondEnd, 1)

	//------------------------------------------------------
	//Set camera
	//------------------------------------------------------
	#local mTussiTranslate = SCR_GetVector ("tussi", "", "translate",	<0,0,0>);
	#local mCamLocation	= <0,0,-40>;
	SCR_SetVector ("cam", "location",	mCamLocation,	mCamLocation,	"linear", mSecondStart,mSecondStart, mSecondEnd, mSecondEnd, 1)
	SCR_SetVector ("cam", "lookat", mTussiTranslate, mTussiTranslate, "linear", mSecondStart, mSecondStart, mSecondEnd, mSecondEnd, 1)



	// ************************************************************************************************************************
	// ************************************************************************************************************************
	//
	// Scene 5 - Landing
	//
	// ************************************************************************************************************************
	// ************************************************************************************************************************

	//------------------------------------------------------
	//Start the scene
	//------------------------------------------------------
	SCR_SetScene("landing")
	SCR_FillSceneVarsAll (mSecondStart, mSecondEnd, mSecond0, mSecond1, mSecond2, mSecond3)

	
	//------------------------------------------------------
	//Set the light-vector
	//------------------------------------------------------
	SCR_SetVector ("lig", "vector", <-30000,25000,0>, <-30000,25000,0>, "linear", 0,0, mSecondEnd, mSecondEnd, 1)


	//------------------------------------------------------
	//All Engines running and acceleration of Tussi at once
	//------------------------------------------------------
	#local mEngineOff	= 20;
	#local mSecond2		= mSecondEnd;
	#local mSecond3		= mSecondEnd;
	#local mMaxHeight	= 500;
	#local mSlope		= "bounce+"; //+ is the right one
	SCR_SetNumber ("tussi/engine",		"active", 0, 1, "bool", 0,0,mEngineOff-1, mEngineOff-1, 1)

	SCR_SetVector ("tussi", "translate", <0,mMaxHeight,0>, <0,0,0>, mSlope, 0,0,mEngineOff, mSecondEnd, 1)
	SCR_SetVector ("tussi", "rotate", 	<0,-45,0>, <0,-45,0>, "linear", 0,0,mSecondEnd, mSecondEnd, 1)



	//------------------------------------------------------
	//Set camera - default for this scene
	//Becomes overwritten in some parts
	//Last setted value rules.
	//------------------------------------------------------
	#local mTussiTranslate = SCR_GetVector ("tussi", "", "translate",	<0,0,0>) + <0,5,0>;
	#local mCamLocation	= <0,5,-30>;
	SCR_SetVector ("cam", "location",	mCamLocation,	mCamLocation,	"linear", mSecondStart,mSecondStart, mSecondEnd, mSecondEnd, 1)
	SCR_SetVector ("cam", "lookat", mTussiTranslate, mTussiTranslate, "linear", mSecondStart, mSecondStart, mSecondEnd, mSecondEnd, 1)


	//------------------------------------------------------
	//In the first Seconds set camera much higher
	//After that for a moment near the flight-path
	//------------------------------------------------------
	#local mEnd1	= 5;
	#local mEnd2	= 15;
	#local mEnd3	= mEngineOff;
	SCR_SetVector ("cam", "location",	<0,100,-600>,	<0,100,-600>,	"linear", 0,0,mEnd1,mEnd1, 1)
	SCR_SetVector ("cam", "lookat", <0,mMaxHeight*0.56, 0>, <0,mMaxHeight*0.54,0>, "linear", 0,0,mEnd1,mEnd1, 1)
	
	//This is a bit tricky, have to work on it, sorry.
	//( xValue, mType, mIterations, mOffset )
	#local mTimeMiddle = 1-(1/mEnd3*((mEnd2-mEnd1)/2+mEnd1));
	//#local mTimeMiddle = (1/mEnd3*((mEnd2-mEnd1)/2+mEnd1));
	#local mPosTussiMiddle = mMaxHeight * MA_GetSlope(mTimeMiddle   , mSlope, 1, 0 );
	//MA_Terminal_F("mPosTussiMiddle", mPosTussiMiddle)	//Debug-message because I have had some trouble with positioning.
	#local mPosTussiMiddle = 146;
	SCR_SetVector ("cam", "location",	<0,mPosTussiMiddle,-20>,	<0,mPosTussiMiddle,-20>,	"linear", mEnd1,mEnd1,mEnd2,mEnd2, 1)


	//------------------------------------------------------
	//Pull out all landing-legs, shortly before Engine-Cutoff
	//------------------------------------------------------
	#local mSecond0		= 0;
	#local mSecond1		= mEngineOff - 4;
	#local mSecond2		= mEngineOff - 2;
	#local mSecond3		= mSecondEnd;
	SCR_SetNumber ("tussi/leg1", "stretched", 0, 1, "linear", mSecond0, mSecond1, mSecond2, mSecond3, 1)
	SCR_SetNumber ("tussi/leg2", "stretched", 0, 1, "linear", mSecond0, mSecond1, mSecond2, mSecond3, 1)
	SCR_SetNumber ("tussi/leg3", "stretched", 0, 1, "linear", mSecond0, mSecond1, mSecond2, mSecond3, 1)
	SCR_SetNumber ("tussi/leg4", "stretched", 0, 1, "linear", mSecond0, mSecond1, mSecond2, mSecond3, 1)


	//------------------------------------------------------
	//After Landing unfold Solarcells and rotate them
	//------------------------------------------------------
	SCR_SetNumber ("tussi", "sc-angle",	0, 90,	"cosinus",		20,		20		22,		mSecondEnd, 1)
	SCR_SetNumber ("tussi", "sc-tilt",	0, -40,	"cosinus++",	20.5,	20.5,	22.5,	mSecondEnd, 1)



	// ************************************************************************************************************************
	// ************************************************************************************************************************
	// ************************************************************************************************************************
	// ************************************************************************************************************************
	// ************************************************************************************************************************
	// ************************************************************************************************************************
	// 
	// Output of all the stuff
	// or ...
	// calling the actors.
	// 
	// ************************************************************************************************************************
	// ************************************************************************************************************************
	// ************************************************************************************************************************
	// ************************************************************************************************************************
	// ************************************************************************************************************************
	// ************************************************************************************************************************


	MA_Terminal_S ("Render scene", SCR_GetSceneName())
	

	//--------------------------------------------
	//Looks automatically if some values for camera and light where in use
	//Highly recommended as one of the first lines.
	//--------------------------------------------
	MA_CameraAndLight_Prepare()

	
	//--------------------------------------------
	//Default and for all scenes
	//--------------------------------------------
	#local mTussiCenterType	= "";
	#local mTussiParams		= "";

	
	//#local mParamsEarth = "atmo-type: simple-1; atmo-radius-outer-ppp: 1.030; atmo-default-color: <0.8, 0.8, 0.9, 0.97>;"; //Tests only
	//#local mParamsEarth = "atmo-type: simple-1; atmo-scattering-color: <0.05,0.15,0.9>; atmo-scattering-factor: 0.005;"; //Tests only
	//#local mParamsEarth = "atmo-type: simple-1; rings-type: saturn-1; atmo-outer-radius: 1.015; atmo-emission: 0.000002; atmo-scattering-type: 2; yyatmo-scattering-color: <0.75,0.05,0.09>; atmo-scattering-factor: 0.005;"; //Tests only
	#local mParamsEarth = "atmo-type: simple-1; atmo-outer-radius: 1.015; atmo-emission: 0.000002; atmo-scattering-type: 2; atmo-scattering-factor: 0.005;"; //final params
	
	//#local mParamsEarth = "atmo-scattering-color: <0.1,0.11,0.5>";	//Test only
	//#local mParamsEarth = "atmo-type:";	//Final. Use Defaults as they are.
	
	//#local mParamsEarth = "rings-type: saturn-1; atmo-scattering-factor: 0.005;";	//Like to see earth with saturns rings?
	//#local mParamsEarth = "";	//Final. Use Defaults as they are.
	
	
	
	//--------------------------------------------
	//With SetMarker() and GetMarker() you can toggle on/off some Elements of a scene
	//Remember: When they have to exist you defined above somewhere with SetMarker("stars", 10, 999)
	//--------------------------------------------
	
	#if (SCR_GetMarker("stars") | SCR_GetMarker("sun"))
		sky_sphere {
			#if (SCR_GetMarker("stars"))
				//SF_GetBackgroundStars(1.5,1)
				SF_BackgroundStars_Pigment(2,5)
				rotate SCR_GetVector ("stars", "", "rotate",	<0,0,0>)
			#end
			#if (SCR_GetMarker("sun"))
				SF_BackgroundSun_Pigment(1,3, -180,0)
			#end
		}
	#end
	
	//--------------------------------------------
	//Scene 1
	//--------------------------------------------
	#if (SCR_GetSceneName() = "launch")
	
		#local mTussiCenterType	= "standing";
		#local mTussiParams		= concat (mTussiParams, ";legs-length-factor: 1;booster:1");

		Earth_Surface ()
		
	#end
	
	//--------------------------------------------
	//Scene 2
	//--------------------------------------------
	#if (SCR_GetSceneName() = "leo")
		
		#local mTussiParams		= concat (mTussiParams, ";legs-length-factor: 0;booster:0");
		//#local mHorizonRotate	= <0,104.6,0> + SCR_GetVector ("horizon", "", "rotate",	<0,0,0>);
		#local mHorizonRotate	= <0,0,0> + SCR_GetVector ("horizon", "", "rotate",	<0,0,0>);
		
		object {
			//SF_GetHorizon1_Base ( 100, 0.1, "l", mHorizonRotate, 2) //Diameter, Orbit-Height, Position, Rotation, Clounds (0-2)
			SF_Horizon1 ( "", "", "diameter:1000; height:10", "l", mHorizonRotate) //Diameter, Orbit-Height, Position, Rotation, Clounds (0-2)
		}
		
	#end


	//--------------------------------------------
	//Scene 3
	//The planets are screenplay-compatible.
	//They will look for rotate-value by itself.
	//--------------------------------------------
	#if (SCR_GetSceneName() = "transit")
		
		#local mTussiParams		= concat (mTussiParams, ";legs-length-factor: 0;booster:0; sc-angle: 90; sc-tilt:90");
		
		//Earth
		object {
			SF_Minshara1("earth", "", mParamsEarth)
			//SF_GetGasgiant1("earth", "", mParamsEarth)
			rotate <0,0,-6>		//This only is an additional rotate, to find a nice place where to start
			scale 5000
			translate <-99,0,-0> * 1000
			
		}
		//Moon
		object {
			SF_Moon1("moon", "", "")
			rotate <0,160,0>	//This only is an additional rotate, to find a nice place where to start
			scale 3000
			translate <99,0,-3> * 1000
		}
		
	#end

	//--------------------------------------------
	//Scene 4
	//--------------------------------------------
	#if (SCR_GetSceneName() = "pre-landing")
		
		#local mTussiParams		= concat (mTussiParams, ";legs-length-factor: 0;booster:0; sc-angle: 0; sc-tilt:0");

	#end


	//--------------------------------------------
	//Scene 5
	//--------------------------------------------
	#if (SCR_GetSceneName() = "landing")
		
		#local mTussiParams		= concat (mTussiParams, ";legs-length-factor: 0;booster:0; sc-angle: 0; sc-tilt:0");
		#local mTussiCenterType	= "standing";

		Moon_Surface ()

		//Earth
		object {
			//#local mParamsEarth = concat(mParamsEarth, ";atmo-scattering-factorvvv; 0.00005; ssatmo-emission: 0.0002");	//Like to see earth with saturns rings?
			#local mParamsEarth = concat(mParamsEarth, ";rings-type: saturn-1; atmo-scattering-factor: 0.15");	//Like to see earth with saturns rings?

			SF_Minshara1("", "", mParamsEarth)
			scale 250
			rotate <-20,-90,-20>
			translate <-30,10,99> * 100
		}
		
	#end


	//--------------------------------------------
	//For all scenes
	//This has to happen at the end,
	//because of some declares/locals inside the if-blocks.
	//Remember: Tussi looks for most of her parameters by herself
	//Not very much to do here.
	//--------------------------------------------

	//Create Tussi.
	object {

		//Returns an object with Tussi from foot to head.
		//What she will look like (angle of olarcells, engines running, ...) happens inside TU_GetTussi_Base()
		//All variables defined in the many lines before will evaluated by using the name "tussi", which was used before dozens of time.
		TU_Tussi ("tussi", "", mTussiParams, mTussiCenterType)

		//But we have to rotate her. That she doesnt do automatically. Why? Good question, will think about.
		rotate		SCR_GetVector ("tussi", "", "rotate",	<0,0,0>)
		
		//Okay, and translate her. But makes sense, translate and rotate is not a behavior of tussi. Maybe.
		translate	SCR_GetVector ("tussi", "", "translate",	<0,0,0>)
		
		//This ist the special case mentioned somewhere far above, to not let Tussi create a shadow on the blue ballon on her left.
		#if (SCR_GetNumber ("tussi", "", "hide-shadow", 0) > 0 )
			no_shadow
		#end
		
	}

	
	
	
#end 



// -------------------------------------------------------------------
// -------------------------------------------------------------------
// Definition of objects
// In a real animation you may include all objects in include-files.
// -------------------------------------------------------------------
// -------------------------------------------------------------------



// -------------------------------------------------------------------
// Surface of earth, including blue sky and clouds
// See:
// http://www.f-lohmueller.de/pov_tut/backgrnd/p_sky1.htm
// -------------------------------------------------------------------
#macro Earth_Surface ()

	#local mCloudRotate	= SCR_GetNumber ("clouds", "", "rotate", 0) + 1;
	#local mTransmit	= SCR_GetNumber ("bluesky", "", "transmit", 0);

	//clouds in the sky
	plane{
		<0,1,0>,1 hollow
		texture {
			pigment {
				bozo turbulence 0.75 octaves 6  omega 0.7 lambda 2 
				color_map {
					[0.0  color rgb <0.95, 0.95, 0.95> ]
					[0.05  color rgb <1, 1, 1>*1.25 ]
					[0.15 color rgb <0.85, 0.85, 0.85> ]
					[0.55 color rgbt <1, 1, 1, 1>*1 ]
					[1.0 color rgbt <1, 1, 1, 1>*1 ]
				}
				translate <-mCloudRotate/2+1,0, mCloudRotate + 3>
				translate< 30, 0,-1>
				scale <0.3, 0.4, 0.2>*3
				}
			finish {emission 1 diffuse 0}
		}
		scale 200
	}
	
	//sky - blue background
	//gets dimmed while tussi flies through the clouds
	plane {
		<0,1,0>,1 hollow
		texture {
			pigment { color rgb<0.1,0.3,0.75>*0.7 transmit mTransmit }
			finish { emission 1 diffuse 0}
		}
		scale 10000
	}

	//Fog at the horizon
	fog {
		fog_type   2
		distance   1000
		color      rgb<1,1,1>*0.9 * (1-(mTransmit*0.5))
		fog_offset 0.1
		fog_alt    20
		turbulence 1.8
	}

   //Earth Surface
	plane {
		<0,1,0>, 0
		texture {
			pigment { color rgb<0.35,0.65,0.0>*0.6 }
			normal { bumps 0.75 scale 0.015}
			finish { ambient 0.1 diffuse 0.8}
			scale 30
		}
	}
#end

 

// -------------------------------------------------------------------
// Surface of the moon
// -------------------------------------------------------------------
#macro Moon_Surface ()
	plane {
		<0,1,0>, 0
		texture {
			pigment { color rgb<0.8,0.8,0.8>*0.6 }
			normal { bumps 0.75 scale 0.015}
			finish { ambient 0.1 diffuse 0.8}
			//scale <30,1,30>
			scale 30
		}
	}
#end






//--------------------------------
// Thats the end.
//--------------------------------

//Execute Screenplay
SCR_Start()

//Finally sets camera and light
//Will use all variables set with "cam" and "lig"
MA_CameraAndLight_Set()

//Send some statistics to the terminal (optional)
MA_Finish()


//Output of the Screenplay-Array into a file - Not recommended while rendering animations.
//MA_OutputArrayString(SCR_Data, "SCR_Data.log", 1, "SCR_Data")









